import os

import gi
gi.require_version("Gst", "1.0")
from gi.repository import Gst


# Initialize GStreamer.
Gst.init(None)

# Define audio file location.
audio_file_path = os.path.abspath("song18.mp3")

# Build a playbin pipeline.
textual_pipeline = "playbin uri=file://{}".format(audio_file_path)
pipeline = Gst.parse_launch(textual_pipeline)

# Start playing.
pipeline.set_state(Gst.State.PLAYING)

# Wait until error or EOS.
bus = pipeline.get_bus()
message = bus.timed_pop_filtered(
   Gst.CLOCK_TIME_NONE,
   Gst.MessageType.ERROR | Gst.MessageType.EOS
)

# Free resources.
pipeline.set_state(Gst.State.NULL)
