import gi
gi.require_version("Gst", "1.0")
from gi.repository import Gst


# FUNCTIONS
# =========

def is_visualizer(feature):
    """Return True if FEATURE's klass is Visualization."""
    return (
        isinstance(feature, Gst.ElementFactory) and
        "Visualization" in feature.get_metadata("klass")
    )


# MAIN
# ====

# Initialize GStreamer.
Gst.init(None)

# Show available visualization plugins.
registry = Gst.Registry.get()
vis_plugins = registry.feature_filter(is_visualizer, False)

print("{} Visualization plugins found.".format(len(vis_plugins)))
for plugin in vis_plugins:
    name = plugin.get_plugin_name()
    long_name = plugin.get_metadata("long-name")
    print("NAME:  {}: {}".format(name, long_name))
    print("KLASS: {}".format(plugin.get_metadata("klass")))
    print("-" * 10)
